% Plot Sector Inflation .. US

clear all;
small = 1.0e-10;
big = 1.0e+6;                  
%rng(63761);
 
 % -- File Directories  
  outdir = 'out/';
  figdir = 'fig/';
  matdir = 'mat/';
  
  % -- Read in Inflation Data --- 
  load_data = 0;  % 1 if reloading data from Excel, etc 
  mtoq_agg = 0;   % Temporal aggregation indicator of monthly to quarterly data
  pc_comp_data_calendar_m_and_q_prices;
  pc_comp_data_calendar_m_and_q_real;
  % Data Series Used
  dp_disagg = dp_disagg_q;
  calvec_p = calvec_qp;
  calvec_r = calvec_qr;
  dnobs_p = dnobs_qp;
  calds_p = calds_qp;
  dp_disagg_ma4 = ma(dp_disagg,4);
  dp_disagg_dif = dif(dp_disagg_ma4,4);
  
  % Load CAI
  str = [matdir 'cai'];load(str);
  
  % Dates
  ismpl_p = smpl(calvec_p,[1984 1],[2019 1],4);
  ismpl_r = smpl(calvec_r,[1984 1],[2019 1],4);
  
  dp_disagg_dif_std = NaN(size(dp_disagg_dif));
  dp_disagg_dif_std(ismpl_p==1,:) = (dp_disagg_dif(ismpl_p==1,:)-mean(dp_disagg_dif(ismpl_p==1,:)))./std(dp_disagg_dif(ismpl_p==1,:));
  
  % Plot Level of Disaggregate Inflation
  ax_fs = 15;
  figure;
  pan = {'a';'b';'c';'d';'e';'f';'g';'h';'i';'j';'k';'l';'m';'n';'o';'p';'q';'r';'s';'t'};
  for i = 1:17;
      ss = char(labelvec_disagg(i));
      subplot(6,3,i);
      plot(calvec_r(ismpl_r==1),cai(ismpl_r==1),': r','LineWidth',3);
      hold on;
        plot(calvec_p(ismpl_p==1),dp_disagg_dif_std(ismpl_p==1,i),'- k','LineWidth',2);
      hold off;
      xlim([1980 2020]);
      title(ss);
      ax = gca;
      ax.FontSize = ax_fs;    
  end;
  legend({'Cyclical slack','Sector-specific inflation'},'Position',[0.7 0.12 0.15 0.07])
  set(gcf, 'Position', get(0, 'Screensize'));  % Full Screen
  figure_to_png(figdir,'Plot_Sectoral_Inflation_SlackIndex');
  close(gcf);
  